Index: palm/trunk/SOURCE/pmc_particle_interface.f90
===================================================================
--- palm/trunk/SOURCE/pmc_particle_interface.f90	(revision 4015)
+++ palm/trunk/SOURCE/pmc_particle_interface.f90	(revision 4017)
@@ -90,10 +90,7 @@
        ONLY:  prt_count, particles, grid_particles,                            &
               particle_type, number_of_particles, zero_particle,               &
-              ibc_par_t, ibc_par_lr, ibc_par_ns, alloc_factor
-
-   USE lpm_pack_and_sort_mod
-
-   USE lpm_exchange_horiz_mod,                                                 &
-       ONLY: realloc_particles_array
+              ibc_par_t, ibc_par_lr, ibc_par_ns, alloc_factor, min_nr_particle
+
+!    USE lpm_pack_and_sort_mod
 
 #if defined( __parallel )
@@ -956,5 +953,5 @@
                    prt_count(kp,jp,ip) = prt_count(kp,jp,ip) + 1
                    IF ( prt_count(kp,jp,ip) > SIZE( grid_particles(kp,jp,ip)%particles ) ) THEN
-                      CALL realloc_particles_array( ip, jp, kp )
+                      CALL pmc_realloc_particles_array( ip, jp, kp )
                    ENDIF
                    coarse_particles(jc,ic)%parent_particles(n)%x = xc                   ! Adjust coordinates to child grid
@@ -1082,5 +1079,5 @@
 !- Pack particles (eliminate those marked for deletion),
 !- determine new number of particles
-   CALL lpm_sort_in_subboxes
+!    CALL lpm_sort_in_subboxes
 
 #endif
@@ -1137,5 +1134,5 @@
                 prt_count(k,j,i) = prt_count(k,j,i) + 1
                 IF ( prt_count(k,j,i) > SIZE( grid_particles(k,j,i)%particles ) ) THEN
-                   CALL realloc_particles_array( i, j, k )
+                   CALL pmc_realloc_particles_array( i, j, k )
                 ENDIF
                 grid_particles(k,j,i)%particles(prt_count(k,j,i)) = particle_in_win(pindex)
@@ -1155,5 +1152,63 @@
 #endif
  END SUBROUTINE p_copy_particle_to_org_grid
-
+ 
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> If the allocated memory for the particle array do not suffice to add arriving
+!> particles from neighbour grid cells, this subrouting reallocates the 
+!> particle array to assure enough memory is available. 
+!------------------------------------------------------------------------------!
+ SUBROUTINE pmc_realloc_particles_array ( i, j, k, size_in )
+
+    INTEGER(iwp), INTENT(IN)                       ::  i              !<
+    INTEGER(iwp), INTENT(IN)                       ::  j              !<
+    INTEGER(iwp), INTENT(IN)                       ::  k              !<
+    INTEGER(iwp), INTENT(IN), OPTIONAL             ::  size_in        !<
+
+    INTEGER(iwp)                                   ::  old_size        !<
+    INTEGER(iwp)                                   ::  new_size        !<
+    TYPE(particle_type), DIMENSION(:), ALLOCATABLE ::  tmp_particles_d !<
+    TYPE(particle_type), DIMENSION(500)            ::  tmp_particles_s !<
+
+    old_size = SIZE(grid_particles(k,j,i)%particles)
+
+    IF ( PRESENT(size_in) )   THEN
+       new_size = size_in
+    ELSE
+       new_size = old_size * ( 1.0_wp + alloc_factor / 100.0_wp )
+    ENDIF
+
+    new_size = MAX( new_size, min_nr_particle, old_size + 1 )
+
+    IF ( old_size <= 500 )  THEN
+
+       tmp_particles_s(1:old_size) = grid_particles(k,j,i)%particles(1:old_size)
+
+       DEALLOCATE(grid_particles(k,j,i)%particles)
+       ALLOCATE(grid_particles(k,j,i)%particles(new_size))
+
+       grid_particles(k,j,i)%particles(1:old_size)          = tmp_particles_s(1:old_size)
+       grid_particles(k,j,i)%particles(old_size+1:new_size) = zero_particle
+
+    ELSE
+
+       ALLOCATE(tmp_particles_d(new_size))
+       tmp_particles_d(1:old_size) = grid_particles(k,j,i)%particles
+
+       DEALLOCATE(grid_particles(k,j,i)%particles)
+       ALLOCATE(grid_particles(k,j,i)%particles(new_size))
+
+       grid_particles(k,j,i)%particles(1:old_size)          = tmp_particles_d(1:old_size)
+       grid_particles(k,j,i)%particles(old_size+1:new_size) = zero_particle
+
+       DEALLOCATE(tmp_particles_d)
+
+    ENDIF
+    particles => grid_particles(k,j,i)%particles(1:new_size)
+
+    RETURN
+    
+ END SUBROUTINE pmc_realloc_particles_array
 
 END MODULE pmc_particle_interface
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4015)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4017)
@@ -155,7 +155,4 @@
     USE netcdf_interface,                                                      &
         ONLY:  netcdf_precision, output_for_t0
-
-    USE particle_attributes,                                                   &
-        ONLY:  curvature_solution_effects, iran_part
 
     USE pegrid
@@ -410,6 +407,4 @@
              CASE ( 'current_timestep_number' )
                 READ ( 13 )  current_timestep_number
-             CASE ( 'curvature_solution_effects' )
-                READ ( 13 )  curvature_solution_effects
              CASE ( 'cycle_mg' )
                 READ ( 13 )  cycle_mg
@@ -442,6 +437,4 @@
              CASE ( 'dt_run_control_1d' )
                 READ ( 13 )  dt_run_control_1d
-             CASE ( 'dvrp_filecount' )
-                READ ( 13 )  dvrp_filecount
              CASE ( 'dx' )
                 READ ( 13 )  dx
@@ -676,6 +669,4 @@
              CASE ( 'time_dots' )
                 READ ( 13 )  time_dots
-             CASE ( 'time_dvrp' )
-                READ ( 13 )  time_dvrp
              CASE ( 'time_radiation' )
                 READ ( 13 )  time_radiation
@@ -1349,7 +1340,4 @@
                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'iran' ) ! matching random numbers is still unresolved issue
-                   IF ( k == 1 )  READ ( 13 )  iran, iran_part
-
                 CASE ( 'kh' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -1407,20 +1395,4 @@
                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
-                CASE ( 'pc_av' )
-                   IF ( .NOT. ALLOCATED( pc_av ) )  THEN
-                      ALLOCATE( pc_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   pc_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                              &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'pr_av' )
-                   IF ( .NOT. ALLOCATED( pr_av ) )  THEN
-                      ALLOCATE( pr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   pr_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                              &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
                 CASE ( 'pt' )
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
@@ -1468,28 +1440,4 @@
                    IF ( k == 1 )  READ ( 13 )  tmp_3d
                    ql_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                              &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'ql_c_av' )
-                   IF ( .NOT. ALLOCATED( ql_c_av ) )  THEN
-                      ALLOCATE( ql_c_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   ql_c_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                            &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'ql_v_av' )
-                   IF ( .NOT. ALLOCATED( ql_v_av ) )  THEN
-                      ALLOCATE( ql_v_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   ql_v_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                            &
-                      tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
-
-                CASE ( 'ql_vp_av' )
-                   IF ( .NOT. ALLOCATED( ql_vp_av ) )  THEN
-                      ALLOCATE( ql_vp_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
-                   ENDIF
-                   IF ( k == 1 )  READ ( 13 )  tmp_3d
-                   ql_vp_av(:,nysc-nbgp:nync+nbgp,nxlc-nbgp:nxrc+nbgp) =                           &
                       tmp_3d(:,nysf-nbgp:nynf+nbgp,nxlf-nbgp:nxrf+nbgp)
 
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 4015)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 4017)
@@ -544,5 +544,5 @@
                do_sum, dt_3d, dt_averaging_input, dt_averaging_input_pr, dt_coupling,              &
                dt_data_output_av, dt_disturb, dt_do2d_xy, dt_do2d_xz, dt_do2d_yz, dt_do3d,         &
-               dt_domask,dt_dopts, dt_dopr, dt_dopr_listing, dt_dots, dt_dvrp, dt_run_control,     &
+               dt_domask,dt_dopts, dt_dopr, dt_dopr_listing, dt_dots, dt_run_control,              &
                end_time, first_call_lpm, first_call_mas, galilei_transformation, humidity,         &
                indoor_model, intermediate_timestep_count, intermediate_timestep_count_max,         &
@@ -557,5 +557,5 @@
                time_do2d_xz, time_do2d_yz, time_do3d, time_domask, time_dopr, time_dopr_av,        &
                time_dopr_listing, time_dopts, time_dosp, time_dosp_av, time_dots, time_do_av,      &
-               time_do_sla, time_disturb, time_dvrp, time_run_control, time_since_reference_point, &
+               time_do_sla, time_disturb, time_run_control, time_since_reference_point,            &
                turbulent_inflow, turbulent_outflow, urban_surface,                                 &
                use_initial_profile_as_reference, use_single_reference_value, u_gtrans, v_gtrans,   &
@@ -591,6 +591,6 @@
         ONLY:  lsm_boundary_condition, lsm_energy_balance, lsm_soil_model, skip_time_do_lsm
 
-    USE lpm_mod,                                                                                   &
-        ONLY:  lpm
+    USE lagrangian_particle_model_mod,                                                             &
+        ONLY:  lpm_data_output_ptseries
 
     USE lsf_nudging_mod,                                                                           &
@@ -846,10 +846,4 @@
        ENDIF
     ENDIF
-
-#if defined( __dvrp_graphics )
-!
-!-- Time measurement with dvrp software  
-    CALL DVRP_LOG_EVENT( 2, current_timestep_number )
-#endif
 
     CALL location_message( 'atmosphere (and/or ocean) time-stepping', 'start' )
@@ -1003,5 +997,5 @@
                .AND.  intermediate_timestep_count == 1 )                                           &
           THEN
-             CALL lpm
+             CALL module_interface_actions( 'after_prognostic_equations' )
              first_call_lpm = .FALSE.
           ENDIF
@@ -1541,5 +1535,4 @@
           ENDIF
        ENDDO
-       time_dvrp          = time_dvrp        + dt_3d
        IF ( time_since_reference_point >= skip_time_dosp )  THEN
           time_dosp       = time_dosp        + dt_3d
@@ -1838,21 +1831,8 @@
                ( time_since_reference_point >= particle_advection_start  .AND.                     &
                  first_call_lpm ) )  THEN
-             CALL data_output_ptseries
+             CALL lpm_data_output_ptseries
              time_dopts = MOD( time_dopts, MAX( dt_dopts, dt_3d ) )
           ENDIF
        ENDIF
-
-!
-!--    Output of dvrp-graphics (isosurface, particles, slicer)
-#if defined( __dvrp_graphics )
-       CALL DVRP_LOG_EVENT( -2, current_timestep_number-1 )
-#endif
-       IF ( time_dvrp >= dt_dvrp )  THEN
-          CALL data_output_dvrp
-          time_dvrp = MOD( time_dvrp, MAX( dt_dvrp, dt_3d ) )
-       ENDIF
-#if defined( __dvrp_graphics )
-       CALL DVRP_LOG_EVENT( 2, current_timestep_number )
-#endif
 
 !
@@ -1934,8 +1914,4 @@
     IF ( myid == 0 )  CALL finish_progress_bar
 
-#if defined( __dvrp_graphics )
-    CALL DVRP_LOG_EVENT( -2, current_timestep_number )
-#endif
-
     CALL location_message( 'atmosphere (and/or ocean) time-stepping', 'finished' )
 
Index: palm/trunk/SOURCE/write_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4015)
+++ palm/trunk/SOURCE/write_restart_data_mod.f90	(revision 4017)
@@ -116,7 +116,4 @@
         ONLY:  netcdf_precision, output_for_t0
 
-    USE particle_attributes,                                                   &
-        ONLY:  curvature_solution_effects, iran_part
-
     USE pegrid,                                                                &
         ONLY:  collective_wait, hor_index_bounds, myid, numprocs
@@ -324,7 +321,4 @@
        WRITE ( 14 )  current_timestep_number
 
-       CALL wrd_write_string( 'curvature_solution_effects' ) 
-       WRITE ( 14 )  curvature_solution_effects
-
        CALL wrd_write_string( 'cycle_mg' ) 
        WRITE ( 14 )  cycle_mg
@@ -371,7 +365,4 @@
        CALL wrd_write_string( 'dt_run_control_1d' ) 
        WRITE ( 14 )  dt_run_control_1d
-
-       CALL wrd_write_string( 'dvrp_filecount' ) 
-       WRITE ( 14 )  dvrp_filecount
 
        CALL wrd_write_string( 'dx' ) 
@@ -707,7 +698,4 @@
        WRITE ( 14 )  time_dots
 
-       CALL wrd_write_string( 'time_dvrp' ) 
-       WRITE ( 14 )  time_dvrp
-
        CALL wrd_write_string( 'time_radiation' ) 
        WRITE ( 14 )  time_radiation
@@ -935,7 +923,4 @@
        ENDIF
 
-       CALL wrd_write_string( 'iran' ) 
-       WRITE ( 14 )  iran, iran_part 
-
        CALL wrd_write_string( 'kh' ) 
        WRITE ( 14 )  kh
